/**
 * Informatique Industrielle et Java
 * exercice 5.2 du chapitre 5
 *
 * Projet: gestion de conflits sur un port de communication
 *
 * Cr l'environnement graphique pour illustrer la gestion de conflits
 * les ports disponibles sont affichs dans une JList
 * Deux boutons permettent de fermer et d'ouvrir les ports
 *
 * @author F.Mallet
 * @version 2003.04
 */

import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JButton;

public class Environnement {
	private JFrame fenetre;
	
	public Environnement(String name) {
		fenetre = new JFrame(name);
		
		// L'organisateur cherche les ports disponibles sur le systme est les prsente
		// sous la forme d'un modle pour une JList
		PortOrganisateur organisateur = new PortOrganisateur(name);
		
		// Cette JList prsente les ports disponibles sur le systme
		JList ports = new JList(organisateur);
		fenetre.getContentPane().add(ports);
		
		// Permet d'ouvrir le port slectionn dans la liste
		JButton ouvrirB = new JButton("Ouvrir");
		fenetre.getContentPane().add(ouvrirB, "North");	
		
		// Permer de fermer le port slectionn dans la liste
		JButton fermerB = new JButton("Fermer");
		fenetre.getContentPane().add(fermerB, "South");
		
		// Cette ecouteur ecoute les vnements qui proviennes des deux boutons
		Ecouteur ecouteur = new Ecouteur(organisateur, ports);
		ouvrirB.addActionListener(ecouteur);		
		fermerB.addActionListener(ecouteur);		
		
		fenetre.pack();
		// Lorsque la fentre est ferme, l'application se termine
		fenetre.setDefaultCloseOperation(fenetre.EXIT_ON_CLOSE);
	}
	
	public void affiche() {
		fenetre.setVisible(true);
	}
	
	// Cette application a un paramtre qui reprsente le nom de l'application
	// Ce nom est utilis lors de la gestion des conflits pour afficher un 
	// message explicite.
	static public void main(String []args) {
		if (args.length == 0) {
			System.err.println("Vous devez donner un nom a votre application");
		} else {
			Environnement env = new Environnement(args[0]);
			env.affiche();
		}
	}
}
